#
# Ruby For Kids Projet 6: Devinez le nombre
# Programmeur : Chris Haupt
# Un jeu dans lequel le but consiste à deviner un nombre secret
#

class Lejeu
# Le code de la classe Lejeu va s'insérer ici
TOTAL_TOURS = 3
def initialize(joueur)
  @joueur = joueur
  @tour = 0
  tour_suivant
end
def tour_suivant
  @nombre_secret = 0
  @tour_fini = false
  @tour += 1
  @joueur.prepare_nouveau_tour
end
def tour
  @tour
end
def fini?
  @tour > TOTAL_TOURS
end
def tour_fini?
  @tour_fini
end
def lit_max_valeur
  print "Je vais choisir un nombre entre 1 et combien ? "
  plus_grande_valeur = @joueur.lit_max_valeur
  if plus_grande_valeur <= 1
    puts "Oups! Le nombre doit être plus grand que 1. Essayez encore."
    return false
  else
    return true
  end
end
def lit_total_essais
  moyenne = calcul_moyenne_essai
  puts "Combien d'essais pensez-vous faire ?"
  print "(la moyenne devrait être de #{moyenne}): "
  total_esssais = @joueur.lit_total_essais
  if total_esssais < 1
    puts "Un peu de sérieux, #{@joueur.nom} ?! Vous devez faire au moins un essai !"
    return false
  else
    return true
  end
end
def calcul_moyenne_essai
  essais_typiques = Math.sqrt(@joueur.plus_grande_valeur)
  essais_typiques.round
end
def prepare_nombre_secret
  @nombre_secret = rand(@joueur.plus_grande_valeur) + 1
end
def lit_essai
  print "#{@joueur.nom}, quel nombre proposez-vous ? "
  @joueur.lit_essai
  compare_essai_nombre_secret
end
def compare_essai_nombre_secret
  if @joueur.essai_actuel == @nombre_secret
    @tour_fini = true
    puts "OUAOUH!!!!! Vous l'avez deviné !"
    calculer_score
  else
    montrer_indication
  end
end
def montrer_indication
  indic = ["bas", "haut"]
  if @joueur.essai_actuel < @nombre_secret
    indic_index = 0
  else
    indic_index = 1
  end
  if !vrai_faux?
    indic_index = indic_index - 1
    indic_index = indic_index.abs
  end
  puts "INDICATION : Vous êtes trop #{indic[indic_index]}"
end
def vrai_faux?
  rand(100) >= 4
end
def calculer_score
  score = 0
  if @joueur.compteur_essais > @joueur.total_essais
    score = 1
  elsif @joueur.total_essais < calcul_moyenne_essai
    score = 3
  else
    score = 5
  end
  @joueur.add_score(score)
end
def affiche_resultats
  puts "Nombre d'essais : #{@joueur.compteur_essais} Objectif : #{@joueur.total_essais}"
end
def affiche_score_final
  puts "Le score final pour #{@joueur.nom} est #{@joueur.score}"
end
end

class Joueur
# Le code de la classe Joueur va s'insérer ici
def initialize(nom)
  @nom = nom
  @score = 0
  prepare_nouveau_tour
end
def prepare_nouveau_tour
  @total_essais = 0
  @plus_grande_valeur = 0
  @essai_actuel = 0
  @nb_courant_essais = 0
end
def nom
  @nom
end
def score
  @score
end
def total_essais
  @total_essais
end
def plus_grande_valeur
  @plus_grande_valeur
end
def essai_actuel
  @essai_actuel
end
def compteur_essais
  @nb_courant_essais
end
def add_score(points)
   @score += points
end
def lit_max_valeur
  @plus_grande_valeur = gets.to_i
end
def lit_total_essais
  @total_esssais = gets.to_i
end
def lit_essai
  @nb_courant_essais += 1
  @essai_actuel = gets.to_i
end
end


puts "Bienvenue dans le jeu : Devine un nombre"
puts "Nous allons jouer en #{Lejeu::TOTAL_TOURS} tours. Le but : deviner mon nombre secret."
# puts "Je réfléchis au nombre minimum d'essais..."
puts "Vous allez aussi estimer le nombre d'essais."
puts "Si vous trouvez le nombre secret en moins d'essais, vous gagnerez des points de bonus !"
puts ""

print "Quel est votre nom ? "
nom = gets.chomp
joueur = Joueur.new(nom)
jeu = Lejeu.new(joueur)

while !jeu.fini? do
  puts ""
  puts "------> Tour ##{jeu.tour}"
  puts ""

  if jeu.lit_max_valeur
    if jeu.lit_total_essais

      jeu.prepare_nombre_secret
      while !jeu.tour_fini? do
        puts ""
        jeu.lit_essai
        jeu.affiche_resultats
      end
      jeu.tour_suivant

    end
  end
end
puts ""
jeu.affiche_score_final



