
class Paille
  COURTE_PAILLE = 5
  LONGUE_PAILLE = 20
  def initialize(taille)
    @taille_paille = taille
  end
# Le reste du code de la classe va venir ici
def courte?
  @taille_paille == COURTE_PAILLE
end
def apparence
  '=' * @taille_paille
end
def self.creer_botte(court, long)
  botte = []
  1.upto(court) do
    botte << Paille.new(COURTE_PAILLE)
  end
  1.upto(long) do
    botte << Paille.new(LONGUE_PAILLE)
  end
  botte
end
end


class Joueur
  def initialize(nom)
    @nom = nom
  end
# Le reste du code de la classe va venir ici
attr_reader :nom
attr_accessor :paille
def apparence
  "#{paille.apparence} #{nom}"
end
def courte_paille?
  paille.courte?
end

end



class Jeu
def initialize(noms_joueurs)
  @joueurs = []
  noms_joueurs.each do |nom|
    @joueurs.push(Joueur.new(nom))
  end
  @tours = 1
end
# Le reste du code de la classe va venir ici
def fini?
  @joueurs.length <= 1
end
def afficher_tour
  puts ""
  puts "----> Tour #{@tours}"
  puts ""
end
def jouer_tour
  botte_paille = nouvelle_botte
  0.upto(@joueurs.length - 1) do |indice|
    joueur = @joueurs[indice]
    joueur.paille = botte_paille.pop
  end
end
def nouvelle_botte
  nombre_joueurs = @joueurs.length
  botte = Paille.creer_botte(1, nombre_joueurs - 1)
  botte.shuffle
end
def afficher_resultats
  @joueurs.each do |joueur|
    puts joueur.apparence
  end
end
def terminer_tour
  @joueurs.delete_if do |joueur|
    joueur.courte_paille?
  end
  @tours += 1
end
def afficher_gagnant
  dernier_joueur = @joueurs.first
  puts ""
  puts "Le vainqueur est #{dernier_joueur.nom}"
  puts ""
end
end





puts "Bienvenue dans le jeu de la courte paille !"
puts "À chaque tour, les joueurs tirent une paille."
puts "Celui qui a la paille la plus courte est éliminé, et un  nouveau tour commence."
puts "Le dernier qui reste a gagné !"

JOUEURS = %w(anne berthy chris daniel élisa franck gloria hermione ivo jade)

jeu = Jeu.new(JOUEURS)

while !jeu.fini? do
  jeu.afficher_tour
  jeu.jouer_tour
  jeu.afficher_resultats
  jeu.terminer_tour
end
jeu.afficher_gagnant

