class Jeu
# Le code vient s'insérer ici
attr_reader :joueurs, :paquet, :banque, :tour
MONTANT_MIN = 1

def initialize(joueurs)
  @joueurs = joueurs
  @paquet = Paquet.new(Carte.creer_cartes)
  @paquet.melange
  @banque = 0
  @tour = 0
end
def joueurs_restant
  joueurs.count {|joueur| !joueur.est_elimine?}
end

def nouveau_tour
  @tour += 1
  joueurs.each do |joueur|
    joueur.jeter_main
  end
end

def mise
  joueurs.each do |joueur|
    if not joueur.est_elimine?
      @banque = @banque + joueur.payer(MONTANT_MIN)
    end
  end
end

def distribue_cartes(nb_cartes)
  joueurs.each do |joueur|
    next if joueur.est_elimine?
    1.upto(nb_cartes) do
      joueur.prend_carte(paquet.distribue)
    end
  end
end

def tri_cartes
  joueurs.each do |joueur|
    next if joueur.est_elimine?
    joueur.trier_main
  end
end

def joueurs_pari
  joueurs.each do |joueur|
    if joueur.est_elimine?
      puts "#{joueur.nom} passe. (Plus de jetons !)"
    else
      print "#{joueur.nom} peut miser entre 0 et #{max_pari(joueur)}: "
      pari = gets.to_i
      if pari < 0 || pari > max_pari(joueur)
        pari = 0
      end
      puts "#{joueur.nom} mise #{pari}"
      joueur.pari = pari
    end
  end
end

def max_pari(joueur)
  [joueur.jetons, banque].min
end

def afficher_jetons
  joueurs.each do |joueur|
    if joueur.est_elimine?
      puts "#{joueur.nom} a été éliminé."
    else
      puts "#{joueur.nom} a #{joueur.jetons} jetons."
    end
  end
end

def afficher_cartes
  joueurs.each do |joueur|
    puts "Le joueur #{joueur.nom} "
    if joueur.est_elimine?
      puts "a été éliminé !"
    else
	  puts "a comme cartes : "
      joueur.main.each do |carte|
        puts carte.to_s
      end
    end
    puts ""
  end
end

def determiner_resultats
  joueurs.each do |joueur|
    if not joueur.est_elimine?
      carte_basse = joueur.main[0]
      carte_haute = joueur.main[1]
      carte_milieu = joueur.main[2]
      if Carte.compare_rang(carte_basse, carte_milieu) == 0 || Carte.compare_rang(carte_haute,carte_milieu) == 0
        puts "#{joueur.nom} a une correspondance exacte et perd deux fois sa mise !"
        jetons = joueur.payer(joueur.pari * 2)
      elsif Carte.compare_rang(carte_milieu, carte_basse) < 0 || Carte.compare_rang(carte_milieu, carte_haute) > 0
        puts "#{joueur.nom} n'était pas au milieu. La mise est perdue !"
        jetons = joueur.payer(joueur.pari)
      else
        puts "#{joueur.nom} gagne sa mise !"
        jetons = -joueur.pari
        joueur.gagne(joueur.pari)
      end
      @banque = @banque + jetons
      if @banque <= 0
        puts "Le donneur manque de jetons. Tout le monde doit miser à nouveau !"
      end
      while @banque <= 0
        mise
      end
    end
  end
end

def jeu_fini
  puts "Fin du jeu !"
  joueurs.sort! do |joueur1, joueur2|
    joueur1.jetons <=> joueur2.jetons
  end
  puts "Le gagnant est #{joueurs.last.nom}"
end

def jeu
  while paquet.taille > (joueurs.length * 3) && joueurs_restant > 1 do
    nouveau_tour
    puts "-" * 40
    puts "Tour #{tour}! Le donneur a #{banque} jetons."
    puts "-" * 40
    puts "Tout le monde mise."
    mise
    puts "Le donneur a maintenant #{banque} jetons."
    distribue_cartes(2)
    tri_cartes
    puts "---> Cartes courantes :\n"
    afficher_cartes
    puts "---> Paris des joueurs :\n"
    joueurs_pari
    puts "\n---> Le donneur distribue une nouvelle carte\n"
    distribue_cartes(1)
    afficher_cartes
    puts "---> Détermination des résultats\n"
    determiner_resultats
    puts "\n---> Nouvelle situation\n"
    afficher_jetons
    puts ""
  end
  jeu_fini
end

end
