require 'gosu'
require_relative 'niveau'
require_relative 'joueur'

class Jeu
NIVEAU1 = [
"+------------------+",
"|D.|....T..........|",
"|..|.--------..|++.|",
"|..|.|....|T|..|T..|",
"|.+|.|.S|.|....|...|",
"|..|.|---.|.|--|...|",
"|..|.|....|.|......|",
"|+.|.|......|..|-|.|",
"|..|.|-----.|..|+|.|",
"|..|T.......|..|+|.|",
"|.++--------+..|+|.|",
"|.+....+++.....|+|.|",
"|...++.....+++.|+|.|",
"|---------------+..|",
"|T+|......|.....|.||",
"|..|..|......+T.|.||",
"|+...+|---------+..|",
"|..|.............+.|",
"|T+|..++++++++++...|",
"+------------------+"
]


def initialize(fenetre)
  @fenetre = fenetre
  @joueur = Joueur.new(@fenetre, 0, 0)
  @niveau = Niveau.new(@fenetre, @joueur, NIVEAU1)
  @font = Gosu::Font.new(32)
  @heure_debut = Time.now.to_i
end


def button_down(id)
  @niveau.button_down(id)
end

def update
  @niveau.update
  if !@niveau.niveau_fini?
    @heure_courante = Time.now.to_i
  end
end

def draw
  @niveau.draw
  dessin_ath
end

def dessin_ath
  if @niveau.niveau_fini?
#    @font.draw("JEU FINI !", 170, 150, 10)
    @font.draw("GAME OVER !", 170, 150, 10, 2, 2)
    @font.draw("#{@joueur.score} trésors collectés en #{temps_en_secondes} secondes!", 110, 300, 10)
  else
    @font.draw("Temps : #{temps_en_secondes}", 4, 2, 10)
    @font.draw("Score : #{@joueur.score}", 510, 2, 10)
  end
end

def temps_en_secondes
  @heure_courante - @heure_debut
end

end


