require 'gosu'

class Disque
  DISQUE_HAUTEUR = 30
  DISQUE_BASE = 40
  DISQUE_INTER = 10

attr_reader :numero
attr_accessor :piquet

def initialize(fenetre, numero, piquet_depart)
  @fenetre = fenetre
  @numero = numero
  @hauteur = DISQUE_HAUTEUR
  @largeur = DISQUE_BASE * (@numero + 1)
  @couleur = Gosu::Color.argb(0xaaff00ff)
  @couleur_select = Gosu::Color.argb(0xaaffeeff)
  @select = false
  @x = 0
  @y = 0
  @piquet = piquet_depart
  piquet_depart.ajoute_disque(self)
end

def au_dessus?
  @piquet.dernier == self
end

def bascule_select
  @select = !@select
end

def dedans?(souris_x, souris_y)
  souris_x >= @x && souris_x <= @x + @largeur &&
  souris_y >= @y && souris_y <= @y + @hauteur
end

def draw
  if @piquet
    @x = @piquet.centre - @largeur / 2
    position = @piquet.position_disque(self)
    if position
      if @select
        c = @couleur_select
      else
        c = @couleur
      end
      # calcule la position y en fonction de la hauteur du piquet
      @y = @piquet.base - @hauteur - (position * (@hauteur + DISQUE_INTER))
      @fenetre.draw_quad(@x, @y, c,
        @x + @largeur, @y, c,
        @x + @largeur, @y + @hauteur, c,
        @x, @y + @hauteur, c)
    end
  end
end

end

