require 'gosu'
require_relative 'disque'
require_relative 'piquet'

class Jeu
  PIQUET_BASE = 150
  PIQUET_GAUCHE = 120
  PIQUET_INTER = 240
  PIQUET_LARGEUR = 40
  PIQUET_HAUTEUR = 400
  NB_DISQUES = 5

def initialize(fenetre)
  @fenetre = fenetre
  @font = Gosu::Font.new(32)
  @heure_debut = Time.now.to_i
  @piquets = []
  @disques = []
  initialise_piquets
  initialise_disques
  @disque_courant = nil
  @nb_deplacements = 0
end

def initialise_piquets
  0.upto(2) do |index|
    @piquets << Piquet.new(@fenetre, PIQUET_GAUCHE + (index * PIQUET_INTER), PIQUET_BASE, PIQUET_LARGEUR, PIQUET_HAUTEUR)
  end
end

def initialise_disques
  piquet_1 = @piquets.first
  0.upto(NB_DISQUES - 1) do |index|
    disque = Disque.new(@fenetre, index, piquet_1)
    @disques << disque
  end
  piquet_1.trier_disques
end

def select_disque(disque)
  if @disque_courant == disque
    return
  elsif @disque_courant
    @disque_courant.bascule_select
  end
  @disque_courant = disque
  if disque
    @disque_courant.bascule_select
  end
end

def button_down(id)
  if id == Gosu::MsLeft
    if @disque_courant
      piquet_cible = @piquets.find do |piquet|
        piquet.dedans?(@fenetre.mouse_x, @fenetre.mouse_y)
      end
      if piquet_cible && piquet_cible.deplacement_valide?(@disque_courant)
        piquet_cible.deplace_disque(@disque_courant)
        select_disque(nil)
        @nb_deplacements += 1
        return
      end
	end
    disque_cible = @disques.find do |disque|
      disque.dedans?(@fenetre.mouse_x, @fenetre.mouse_y)
    end
    select_disque(disque_cible)
  end
end

def draw
  @piquets.each {|piquet| piquet.draw}
  @disques.each {|disque| disque.draw}
  @font.draw("Déplacez les tours de gauche à droite !", 4, 2, 10)
  @font.draw("Déplacements : #{@nb_deplacements}", 540, 2, 10)
end

end
