require 'gosu'

class Piquet

def initialize(fenetre, x, y, largeur=40, hauteur=400)
  @hauteur = hauteur
  @largeur = largeur
  @x = x
  @y = y
  @couleur = Gosu::Color.argb(0xaa0000ff)
  @fenetre = fenetre
  @disques = []
end

def draw
  @fenetre.draw_quad(
      @x, @y, @couleur, 
      @x + @largeur, @y, @couleur, 
      @x + @largeur, @y + @hauteur, @couleur, 
      @x, @y + @hauteur, @couleur)
end

def ajoute_disque(disque)
  @disques.push(disque)
  disque.piquet = self
end

def enleve_disque(disque)
  @disques.delete(disque)
  disque.piquet = nil
end

def dernier
  @disques.last
end

def position_disque(disque)
  @disques.find_index(disque)
end

def trier_disques
  @disques.sort_by! { |disque| -disque.numero }
end

def deplacement_valide?(disque)
  disque.au_dessus? && (@disques.empty? || disque.numero < dernier.numero)
end

def deplace_disque(disque)
  disque.piquet.enleve_disque(disque)
  ajoute_disque(disque)
end

def dedans?(souris_x, souris_y)
  souris_x >= @x && souris_x <= @x + @largeur &&
  souris_y >= @y && souris_y <= @y + @hauteur
end

def centre
  @x + (@largeur / 2)
end

def base
  @y + @hauteur
end

end

